Index: EcnlProtoTool/trunk/asp3_dcre/.cproject
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/.cproject	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/.cproject	(revision 429)
@@ -49,5 +49,5 @@
 							<option id="ilg.gnuarmeclipse.managedbuild.cross.option.addtools.createflash.1804182567" name="Create flash image" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.addtools.createflash" value="true" valueType="boolean"/>
 							<targetPlatform archList="all" binaryParser="org.eclipse.cdt.core.ELF" id="ilg.gnuarmeclipse.managedbuild.cross.targetPlatform.74647507" isAbstract="false" osList="all" superClass="ilg.gnuarmeclipse.managedbuild.cross.targetPlatform"/>
-							<builder buildPath="${workspace_loc:/asp3_dcre}/Debug" id="com.renesas.cdt.managedbuild.gcc.rz.builder.460934776" keepEnvironmentInBuildfile="false" managedBuildOn="false" name="GCC for Renesas Builder" superClass="com.renesas.cdt.managedbuild.gcc.rz.builder"/>
+							<builder buildPath="${workspace_loc:/asp3_dcre}/Debug" id="com.renesas.cdt.managedbuild.gcc.rz.builder.460934776" keepEnvironmentInBuildfile="false" managedBuildOn="false" name="GCC for Renesas Builder" parallelBuildOn="true" parallelizationNumber="optimal" superClass="com.renesas.cdt.managedbuild.gcc.rz.builder"/>
 							<tool id="com.renesas.cdt.managedbuild.gcc.rz.tool.assembler.1682623852" name="Cross ARM GNU Assembler" superClass="com.renesas.cdt.managedbuild.gcc.rz.tool.assembler">
 								<option id="ilg.gnuarmeclipse.managedbuild.cross.option.assembler.usepreprocessor.1607103230" name="Use preprocessor" superClass="ilg.gnuarmeclipse.managedbuild.cross.option.assembler.usepreprocessor" value="true" valueType="boolean"/>
@@ -94,4 +94,5 @@
 				<option id="toolchain.id" value="gcc-arm-embedded"/>
 				<option id="toolchain.version" value="6.3.1.20170620"/>
+				<option id="toolchain.enable" value="true"/>
 			</storageModule>
 		</cconfiguration>
@@ -112,3 +113,4 @@
 		</configuration>
 	</storageModule>
+	<storageModule moduleId="org.eclipse.cdt.make.core.buildtargets"/>
 </cproject>
Index: EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile	(revision 429)
@@ -6,5 +6,5 @@
 #  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 #                              Toyohashi Univ. of Technology, JAPAN
-#  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+#  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
 #              Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -81,4 +81,10 @@
 
 #
+#  システムサービスコールライブラリ（libsyssvc.a）のディレクトリ名
+#  （システムサービスコールライブラリもmake対象にする時は，空に定義する）
+#
+SYSSVC_LIB = 
+
+#
 #  カーネルを関数単位でコンパイルするかどうかの定義
 #
@@ -89,4 +95,9 @@
 #
 OMIT_TECS = 
+
+#
+#  TECS関係ファイルのディレクトリの定義
+#
+TECSDIR = 
 
 #
@@ -119,7 +130,8 @@
 
 #
-#  依存関係ファイルを置くディレクトリの定義
-#
-DEPDIR = deps
+#  中間オブジェクトファイルと依存関係ファイルを置くディレクトリの定義
+#
+OBJDIR = obj
+DEPDIR = obj
 
 #
@@ -150,4 +162,6 @@
 endif
 
+TINETDIR = tinet
+
 #
 #  mbedサービスの定義
@@ -159,5 +173,5 @@
 #  共通コンパイルオプションの定義
 #
-COPTS := -g -std=gnu99 $(COPTS)
+COPTS := -g -std=gnu99 -ffunction-sections -fdata-sections $(COPTS)
 ifndef OMIT_WARNING_ALL
 	COPTS := -Wall $(COPTS)
@@ -171,5 +185,5 @@
 CDEFS := $(CDEFS) 
 INCLUDES := -I. -I$(SRCDIR)/include $(INCLUDES) -I$(SRCDIR)
-LDFLAGS := $(LDFLAGS) -Wl,-Map=$(OBJNAME).map,--cref
+LDFLAGS := $(LDFLAGS) -L.
 LIBS := $(LIBS) $(CXXLIBS)
 CFLAGS = $(COPTS) $(CDEFS) $(INCLUDES)
@@ -191,5 +205,5 @@
 	APPL_COBJS := sample1n.o sample1.o
 endif
-APPL_COBJS := $(APPL_COBJS) log_output.o vasyslog.o t_perror.o strerror.o
+APPL_COBJS := $(APPL_COBJS) log_output.o vasyslog.o t_perror.o strerror.o mbed_stub.o
 APPL_CFLAGS := $(APPL_CFLAGS)
 ifdef APPLDIRS
@@ -197,5 +211,4 @@
 endif
 
-TINETDIR = tinet
 ifdef TINETDIR
 	#
@@ -221,4 +234,7 @@
 	SUPPORT_UDP = true
 
+	# IGMPを有効に設定
+	#SUPPORT_IGMP = true
+
 	#
 	#  ネットワークサービスの Makefile のインクルード
@@ -230,18 +246,34 @@
 #  システムサービスに関する定義
 #
+ifdef TCINSTALL
+GCC_PATH = $(TCINSTALL)
+else
+GCC_PATH = $(shell which $(CC))/../../
+endif
+MALLOC_LIB = "${GCC_PATH}arm-none-eabi/lib/thumb/v7-ar/fpv3/hard/libc.a"
+MALLOC_OBJS = lib_a-reent.o lib_a-impure.o lib_a-malloc.o lib_a-mallocr.o lib_a-calloc.o lib_a-callocr.o lib_a-realloc.o lib_a-reallocr.o lib_a-sbrkr.o lib_a-freer.o
+
 SYSSVC_DIRS := $(TECSGENDIR) $(SRCDIR)/tecs_kernel \
 				$(SYSSVC_DIRS) $(SRCDIR)/syssvc
 SYSSVC_ASMOBJS := $(SYSSVC_ASMOBJS)
-SYSSVC_COBJS := $(INIT_TECS_COBJ) $(TECS_COBJS) $(SYSSVC_COBJS) \
-				 $(CXXRTS)
+SYSSVC_COBJS := $(SYSSVC_COBJS) $(TECS_COBJS) \
+				$(INIT_TECS_COBJ) $(CXXRTS)
 SYSSVC_CFLAGS := $(SYSSVC_CFLAGS)
 INCLUDES := $(INCLUDES) -I$(TECSGENDIR) -I$(SRCDIR)/tecs_kernel -I../../musl-1.1.18/include
 
 #
+#  トレースログ記録のサンプルコードに関する定義
+#
+ifdef ENABLE_TRACE
+	COPTS := $(COPTS) -DTOPPERS_ENABLE_TRACE
+	SYSSVC_DIRS := $(SYSSVC_DIRS) $(SRCDIR)/arch/tracelog
+endif
+
+#
 #  ターゲットファイル
 #
 .PHONY: all
 ifndef OMIT_TECS
-all: tecs
+all: tecs | $(DEPDIR)
 #	@$(MAKE) check
 	@$(MAKE) check $(OBJNAME).bin
@@ -258,4 +290,5 @@
 #  コンフィギュレータに関する定義
 #
+CFG_KERNEL := --kernel asp
 ifndef TINETDIR
   CFG_TRB := -T $(TARGETDIR)/target_kernel.trb
@@ -266,5 +299,5 @@
   CFG_TABS := --api-table $(TINET_ROOT)/tcpip_api.def:tcpip \
 			--api-table $(SRCDIR)/kernel/kernel_api.def:kernel \
-			--symval-table $(SRCDIR)/tinet/tcpip_sym.def \
+			--symval-table $(TINET_ROOT)/tcpip_sym.def \
 			--symval-table $(SRCDIR)/kernel/kernel_sym.def $(CFG_TABS)
 endif
@@ -272,6 +305,7 @@
 CFG_COBJS := kernel_cfg.o $(CFG_COBJS)
 CFG_OBJS := $(CFG_ASMOBJS) $(CFG_COBJS)
+CFG_CFLAGS := -DTOPPERS_CB_TYPE_ONLY $(CFG_CFLAGS)
+
 CFG2_OUT_SRCS := kernel_cfg.h kernel_cfg.c $(CFG2_OUT_SRCS)
-CFG_CFLAGS := -DTOPPERS_CB_TYPE_ONLY $(CFG_CFLAGS)
 
 #
@@ -304,7 +338,5 @@
 					$(foreach file,$(KERNEL_FCSRCS),$(file:.c=.o))
 endif
-ifdef OMIT_OFFSET_H
-	OFFSET_H =
-else
+ifdef TARGET_OFFSET_TRB
 	OFFSET_H = offset.h
 endif
@@ -322,5 +354,5 @@
 endif
 ifndef TARGET_TCPIP_TRB
-	TARGET_TCPIP_TRB := $(SRCDIR)/tinet/tinet.trb
+	TARGET_TCPIP_TRB := $(SRCDIR)/$(TINETDIR)/tinet.trb
 endif
 
@@ -332,11 +364,29 @@
 vpath %.cfg $(APPL_DIRS)
 vpath %.cdl $(APPL_DIRS)
+vpath %.bin $(APPL_DIRS)
+
+#
+#  中間オブジェクトファイルを置くディレクトリの処理
+#
+APPL_ASMOBJS   := $(addprefix $(OBJDIR)/, $(APPL_ASMOBJS))
+APPL_CXXOBJS   := $(addprefix $(OBJDIR)/, $(APPL_CXXOBJS))
+APPL_COBJS     := $(addprefix $(OBJDIR)/, $(APPL_COBJS))
+SYSSVC_ASMOBJS := $(addprefix $(OBJDIR)/, $(SYSSVC_ASMOBJS))
+SYSSVC_COBJS   := $(addprefix $(OBJDIR)/, $(SYSSVC_COBJS))
+KERNEL_ASMOBJS := $(addprefix $(OBJDIR)/, $(KERNEL_ASMOBJS))
+KERNEL_COBJS   := $(addprefix $(OBJDIR)/, $(KERNEL_COBJS))
+KERNEL_LCOBJS  := $(addprefix $(OBJDIR)/, $(KERNEL_LCOBJS))
+CFG_ASMOBJS    := $(addprefix $(OBJDIR)/, $(CFG_ASMOBJS))
+CFG_COBJS      := $(addprefix $(OBJDIR)/, $(CFG_COBJS))
+CFG_DMY        := $(addprefix $(OBJDIR)/, $(CFG_DMY))
+MALLOC_OBJS    := $(addprefix $(OBJDIR)/, $(MALLOC_OBJS))
 
 #
 #  コンパイルのための変数の定義
 #
-KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS)
+APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS)
 SYSSVC_OBJS = $(SYSSVC_ASMOBJS) $(SYSSVC_COBJS) $(HIDDEN_OBJS)
-APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS)
+KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS) $(MALLOC_OBJS)
+CFG_OBJS = $(CFG_ASMOBJS) $(CFG_COBJS)
 ALL_OBJS = $(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
 											$(END_OBJS) $(HIDDEN_OBJS)
@@ -350,4 +400,12 @@
 	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L.
 endif
+ifdef SYSSVC_LIB
+	LIBS_DEP := $(LIBS_DEP) $(SYSSVC_LIB)/libsyssvc.a
+	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L$(SYSSVC_LIB)
+	REALCLEAN_FILES := $(REALCLEAN_FILES) libsyssvc.a
+else
+	LIBS_DEP := $(LIBS_DEP) libsyssvc.a
+	OBJ_LDFLAGS := $(OBJ_LDFLAGS) -L.
+endif
 
 ifdef TEXT_START_ADDRESS
@@ -372,5 +430,5 @@
 tecs $(TECSGEN_SRCS) $(TECS_HEADERS): $(TECSGEN_TIMESTAMP) ;
 $(TECSGEN_TIMESTAMP): $(APPL_CDL) $(TECS_IMPORTS)
-	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(TECS_CPP)" -g $(TECSGENDIR)
+	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(subst ", \", $(TECS_CPP))" -g $(TECSGENDIR)
 
 #
@@ -379,11 +437,10 @@
 cfg1_out.c cfg1_out.db: cfg1_out.timestamp ;
 cfg1_out.timestamp: $(APPL_CFG) $(TECSGEN_TIMESTAMP)
-	echo $(CFG_TABS)
-	$(CFG) --pass 1 --kernel asp $(INCLUDES) $(CFG_TABS) \
+	$(CFG) --pass 1 $(CFG_KERNEL) $(INCLUDES) $(CFG_TABS) \
 						-M $(DEPDIR)/cfg1_out_c.d $(TARGET_KERNEL_CFG) $<
 
-$(CFG1_OUT): $(START_OBJS) cfg1_out.o $(CFG_DMY) $(END_OBJS) $(HIDDEN_OBJS)
+$(CFG1_OUT): $(START_OBJS) $(OBJDIR)/cfg1_out.o $(CFG_DMY) $(END_OBJS) $(HIDDEN_OBJS)
 	$(LINK) $(CFLAGS) $(LDFLAGS) $(CFG1_OUT_LDFLAGS) -o $(CFG1_OUT) \
-						$(START_OBJS) cfg1_out.o $(CFG_DMY) $(END_OBJS)
+						$(START_OBJS) $(OBJDIR)/cfg1_out.o $(CFG_DMY) $(LIBS) $(END_OBJS) $(HIDDEN_OBJS)
 
 cfg1_out.syms: $(CFG1_OUT)
@@ -395,5 +452,5 @@
 $(CFG2_OUT_SRCS) cfg2_out.db: kernel_cfg.timestamp ;
 kernel_cfg.timestamp: cfg1_out.db cfg1_out.syms cfg1_out.srec
-	$(CFG) --pass 2 --kernel asp $(INCLUDES) $(CFG_TRB)
+	$(CFG) --pass 2 $(CFG_KERNEL) $(INCLUDES) $(CFG_TRB)
 
 #
@@ -402,5 +459,5 @@
 $(OFFSET_H): offset.timestamp ;
 offset.timestamp: cfg1_out.db cfg1_out.syms cfg1_out.srec
-	$(CFG) --pass 2 -O --kernel asp $(INCLUDES) -T $(TARGET_OFFSET_TRB) \
+	$(CFG) --pass 2 -O $(CFG_KERNEL) $(INCLUDES) -T $(TARGET_OFFSET_TRB) \
 				--rom-symbol cfg1_out.syms --rom-image cfg1_out.srec
 
@@ -414,7 +471,23 @@
 
 #
+#  システムサービスコールライブラリファイルの生成
+#
+libsyssvc.a: $(filter-out $(OBJDIR)/tBannerMain.o, $(SYSSVC_OBJS))
+	rm -f libsyssvc.a
+	$(AR) -rcs libsyssvc.a $(filter-out $(OBJDIR)/tBannerMain.o, $(SYSSVC_OBJS))
+	$(RANLIB) libsyssvc.a
+
+#
+#  並列makeのための依存関係の定義
+#
+$(APPL_OBJS) $(filter-out $(CFG_DMY), $(SYSSVC_OBJS)): | kernel_cfg.timestamp
+$(APPL_ASMOBJS) $(filter-out $(CFG_DMY), $(SYSSVC_ASMOBJS)) $(KERNEL_ASMOBJS) $(CFG_ASMOBJS): \
+														| offset.timestamp
+
+#
 #  特別な依存関係の定義
 #
-tBannerMain.o: $(filter-out tBannerMain.o,$(ALL_OBJS)) $(LIBS_DEP)
+$(OBJDIR)/tBannerMain.o: $(filter-out $(OBJDIR)/tBannerMain.o,$(ALL_OBJS)) \
+																$(LIBS_DEP)
 
 #
@@ -423,6 +496,13 @@
 $(OBJFILE): $(ALL_OBJS) $(LIBS_DEP)
 	$(LINK) $(CFLAGS) $(LDFLAGS) $(OBJ_LDFLAGS) -o $(OBJFILE) \
+			-Wl,-Map=$(OBJNAME).map,--cref -Wl,--gc-sections -Wl,-e_kernel__start,--gc-keep-exported=_kernel_istk \
 			$(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
-			$(ALL_LIBS) $(END_OBJS)
+			-Wl,--start-group $(ALL_LIBS) -Wl,--end-group $(END_OBJS)
+
+#
+#  依存関係フォルダの作成
+#
+$(DEPDIR):
+	mkdir $@
 
 #
@@ -452,5 +532,5 @@
 check: check.timestamp ;
 check.timestamp: cfg2_out.db $(OBJNAME).syms $(OBJNAME).srec
-	$(CFG) --pass 3 --kernel asp -O $(INCLUDES) -T $(TARGET_CHECK_TRB) \
+	$(CFG) --pass 3 $(CFG_KERNEL) -O $(INCLUDES) -T $(TARGET_CHECK_TRB) \
 				--rom-symbol $(OBJNAME).syms --rom-image $(OBJNAME).srec
 	@echo "configuration check passed"
@@ -461,5 +541,5 @@
 .PHONY: clean
 clean:
-	rm -f \#* *~ *.o $(DEPDIR)/*.d $(CLEAN_FILES) check.timestamp
+	rm -f \#* *~ $(OBJDIR)/*.o $(DEPDIR)/*.d $(CLEAN_FILES) check.timestamp
 	rm -f $(OBJFILE) $(OBJNAME).syms $(OBJNAME).srec $(OBJNAME).bin
 	rm -f kernel_cfg.timestamp $(CFG2_OUT_SRCS) cfg2_out.db
@@ -471,9 +551,18 @@
 	rm -f libkernel.a
 endif
+ifndef SYSSVC_LIB
+	rm -f libsyssvc.a
+endif
+	rm -f $(MALLOC_OBJS)
 
 .PHONY: cleankernel
 cleankernel:
 	rm -f $(OFFSET_H) $(KERNEL_LIB_OBJS)
-	rm -f $(KERNEL_LIB_OBJS:%.o=$(DEPDIR)/%.d)
+	rm -f $(KERNEL_LIB_OBJS:$(OBJDIR)/%.o=$(DEPDIR)/%.d)
+
+.PHONY: cleansyssvc
+cleansyssvc:
+	rm -f $(SYSSVC_OBJS)
+	rm -f $(SYSSVC_OBJS:$(OBJDIR)/%.o=$(DEPDIR)/%.d)
 
 .PHONY: realclean
@@ -487,15 +576,15 @@
 #  のみを付けてコンパイルする．
 #
-ALL_CFG_COBJS = $(CFG_COBJS) cfg1_out.o
+ALL_CFG_COBJS = $(CFG_COBJS) $(OBJDIR)/cfg1_out.o
 ALL_CFG_ASMOBJS = $(CFG_ASMOBJS)
 
-$(ALL_CFG_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
-
-$(ALL_CFG_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(CFG_CFLAGS) $<
-
-$(ALL_CFG_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
+$(ALL_CFG_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
+
+$(ALL_CFG_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(CFG_CFLAGS) $<
+
+$(ALL_CFG_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(CFG_CFLAGS) $<
 
 #
@@ -549,64 +638,68 @@
 #  コンパイルルールの定義
 #
-$(KERNEL_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_LCOBJS): %.o:
-	$(CC) -DTOPPERS_$(*F) -o $@ -c -MD -MP -MF $(DEPDIR)/$*.d \
+$(KERNEL_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_LCOBJS): $(OBJDIR)/%.o:
+	$(CC) -c -o $@ -DTOPPERS_$(*F) -MD -MP -MF $(DEPDIR)/$*.d \
 									$(CFLAGS) $(KERNEL_CFLAGS) $<
 
-$(KERNEL_LCOBJS:.o=.s): %.s:
-	$(CC) -DTOPPERS_$(*F) -o $@ -S $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(KERNEL_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
-
-$(SYSSVC_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(SYSSVC_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(SYSSVC_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
-
-$(APPL_COBJS): %.o: %.c
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_COBJS:.o=.s): %.s: %.c
-	$(CC) -S $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_CXXOBJS): %.o: %.cpp
-	$(CXX) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_CXXOBJS:.o=.s): %.s: %.cpp
-	$(CXX) -S $(CFLAGS) $(APPL_CFLAGS) $<
-
-$(APPL_ASMOBJS): %.o: %.S
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+$(KERNEL_LCOBJS:$(OBJDIR)/%.o=%.s): %.s:
+	$(CC) -S -o $@ -DTOPPERS_$(*F) $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(KERNEL_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
+
+$(SYSSVC_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(SYSSVC_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(SYSSVC_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(SYSSVC_CFLAGS) $<
+
+$(APPL_COBJS): $(OBJDIR)/%.o: %.c
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_COBJS:$(OBJDIR)/%.o=%.s): %.s: %.c
+	$(CC) -S -o $@ $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_CXXOBJS): $(OBJDIR)/%.o: %.cpp
+	$(CXX) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_CXXOBJS:$(OBJDIR)/%.o=%.s): %.s: %.cpp
+	$(CXX) -S -o $@ $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(APPL_ASMOBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
+
+$(MALLOC_OBJS): $(OBJDIR)/%.o:
+	$(AR) x $(MALLOC_LIB) $(notdir $@)
+	mv $(notdir $@) $@
 
 #
 #  デフォルトコンパイルルールを上書き
 #
-%.o: %.c
+$(OBJDIR)/%.o: %.c
 	@echo "*** Default compile rules should not be used."
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
 
 %.s: %.c
 	@echo "*** Default compile rules should not be used."
-	$(CC) -S $(CFLAGS) $<
-
-%.o: %.cpp
+	$(CC) -S -o $@ $(CFLAGS) $<
+
+$(OBJDIR)/%.o: %.cpp
 	@echo "*** Default compile rules should not be used."
-	$(CXX) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CXX) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
 
 %.s: %.cpp
 	@echo "*** Default compile rules should not be used."
-	$(CXX) -S $(CFLAGS) $<
-
-%.o: %.S
+	$(CXX) -S -o $@ $(CFLAGS) $<
+
+$(OBJDIR)/%.o: %.S
 	@echo "*** Default compile rules should not be used."
-	$(CC) -c -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $<
Index: EcnlProtoTool/trunk/asp3_dcre/MANIFEST
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/MANIFEST	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/MANIFEST	(revision 429)
@@ -1,4 +1,4 @@
 PACKAGE asp3
-VERSION 3.1.0
+VERSION 3.5.0
 
 configure.rb
@@ -88,5 +88,4 @@
 tecs_kernel/tAlarmNotifier.c
 tecs_kernel/tAlarmNotifier_inline.h
-tecs_kernel/tCpuExceptionHandler.c
 tecs_kernel/tCyclicNotifier.c
 tecs_kernel/tCyclicNotifier_inline.h
@@ -96,5 +95,4 @@
 tecs_kernel/tISR.c
 tecs_kernel/tInitializeRoutine.c
-tecs_kernel/tInterruptHandler.c
 tecs_kernel/tInterruptRequest_inline.h
 tecs_kernel/tKernel_inline.h
@@ -119,4 +117,6 @@
 syssvc/tLogTask.cdl
 syssvc/tLogTaskMain.c
+syssvc/tPutLogSIOPort.c
+syssvc/tPutLogSIOPort.cdl
 syssvc/tSerialAdapter.c
 syssvc/tSerialAdapter.cdl
@@ -129,4 +129,6 @@
 syssvc/tTestService.c
 syssvc/tTestService.cdl
+syssvc/tTestServiceAdapter.c
+syssvc/tTestServiceAdapter.cdl
 syssvc/test_svc.h
 
@@ -141,4 +143,13 @@
 arch/tracelog/tTraceLog.c
 arch/tracelog/tTraceLog.cdl
+
+arch/simtimer/sim_timer.c
+arch/simtimer/sim_timer.cfg
+arch/simtimer/sim_timer.h
+arch/simtimer/sim_timer_cntl.h
+arch/simtimer/tSimTimerCntl.c
+arch/simtimer/tSimTimerCntl.cdl
+arch/simtimer/tSimTimerCntlAdapter.c
+arch/simtimer/tSimTimerCntlAdapter.cdl
 
 utils/applyrename.rb
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/MANIFEST
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/MANIFEST	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/MANIFEST	(revision 429)
@@ -1,4 +1,4 @@
 PACKAGE asp3_arch_arm_gcc
-VERSION 3.1.0
+VERSION 3.2.0
 
 MANIFEST
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/Makefile.core
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/Makefile.core	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/Makefile.core	(revision 429)
@@ -2,5 +2,5 @@
 #		Makefileのコア依存部（ARM用）
 #
-#  $Id$
+#  $Id: Makefile.core 755 2016-06-12 10:08:22Z ertl-hiro $
 #
 
@@ -50,8 +50,9 @@
 #  START_OBJSをstart.oに設定し，LDFLAGSに-nostdlibを追加する．
 #
-START_OBJS = start.o
+START_OBJS := start.o
+START_OBJS := $(addprefix $(OBJDIR)/, $(START_OBJS))
 
-$(START_OBJS): %.o: %.S
-	$(CC) -c $(CFLAGS) $(KERNEL_CFLAGS) $<
+$(START_OBJS): $(OBJDIR)/%.o: %.S
+	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(KERNEL_CFLAGS) $<
 
-LDFLAGS := -nostdlib $(LDFLAGS)
+LDFLAGS := -nodefaultlibs $(LDFLAGS)
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.c	(revision 429)
@@ -137,5 +137,6 @@
  *  ARMv7におけるデータキャッシュの無効化
  *
- *  レベル0のキャッシュのみを無効化する．
+ *  バリアを2か所に入れているのは，ARMアーキテクチャリファレンスマニュ
+ *  アルのサンプルコードを踏襲した．
  */
 #if __TARGET_ARCH_ARM == 7
@@ -144,21 +145,32 @@
 armv7_invalidate_dcache(void)
 {
-	uint32_t	reg;
+	uint32_t	clidr, ccsidr;
+	uint32_t	level, no_levels;
 	uint32_t	way, no_ways, shift_way;
 	uint32_t	set, no_sets, shift_set;
-
-	CP15_WRITE_CSSELR(0U);
-	CP15_READ_CCSIDR(reg);
-	no_sets = ((reg >> 13) & 0x7fffU) + 1;
-	shift_set = (reg & 0x07U) + 4;
-	no_ways = ((reg >> 3) & 0x3ffU) + 1;
-	shift_way = count_leading_zero(no_ways);
-
-	for (way = 0; way < no_ways; way++){
-		for (set = 0; set < no_sets; set++) {
-			reg = (way << shift_way) | (set << shift_set);
-			CP15_WRITE_DCISW(reg);
+	uint32_t	waylevel, setwaylevel;
+
+	CP15_READ_CLIDR(clidr);
+	no_levels = (clidr >> 24) & 0x07U;
+	for (level = 0; level < no_levels; level++) {
+		if (((clidr >> (level * 3)) & 0x07U) >= 0x02U) {
+			CP15_WRITE_CSSELR(level << 1);
+			inst_sync_barrier();
+			CP15_READ_CCSIDR(ccsidr);
+			no_sets = ((ccsidr >> 13) & 0x7fffU) + 1;
+			shift_set = (ccsidr & 0x07U) + 4;
+			no_ways = ((ccsidr >> 3) & 0x3ffU) + 1;
+			shift_way = count_leading_zero(no_ways - 1);
+
+			for (way = 0; way < no_ways; way++) {
+				waylevel = (way << shift_way) | (level << 1);
+				for (set = 0; set < no_sets; set++) {
+					setwaylevel = waylevel | (set << shift_set);
+					CP15_WRITE_DCISW(setwaylevel);
+				}
+			}
 		}
 	}
+	data_sync_barrier();
 }
 
@@ -168,5 +180,6 @@
  *  ARMv7におけるデータキャッシュのクリーンと無効化
  *
- *  レベル0のキャッシュのみをクリーンと無効化する．
+ *  バリアを2か所に入れているのは，ARMアーキテクチャリファレンスマニュ
+ *  アルのサンプルコードを踏襲した．
  */
 #if __TARGET_ARCH_ARM == 7
@@ -175,21 +188,32 @@
 armv7_clean_and_invalidate_dcache(void)
 {
-	uint32_t	reg;
+	uint32_t	clidr, ccsidr;
+	uint32_t	level, no_levels;
 	uint32_t	way, no_ways, shift_way;
 	uint32_t	set, no_sets, shift_set;
-
-	CP15_WRITE_CSSELR(0U);
-	CP15_READ_CCSIDR(reg);
-	no_sets = ((reg >> 13) & 0x7fffU) + 1;
-	shift_set = (reg & 0x07U) + 4;
-	no_ways = ((reg >> 3) & 0x3ffU) + 1;
-	shift_way = count_leading_zero(no_ways);
-
-	for (way = 0; way < no_ways; way++){
-		for (set = 0; set < no_sets; set++) {
-			reg = (way << shift_way) | (set << shift_set);
-			CP15_WRITE_DCCISW(reg);
+	uint32_t	waylevel, setwaylevel;
+
+	CP15_READ_CLIDR(clidr);
+	no_levels = (clidr >> 24) & 0x07U;
+	for (level = 0; level < no_levels; level++) {
+		if (((clidr >> (level * 3)) & 0x07U) >= 0x02U) {
+			CP15_WRITE_CSSELR(level << 1);
+			inst_sync_barrier();
+			CP15_READ_CCSIDR(ccsidr);
+			no_sets = ((ccsidr >> 13) & 0x7fffU) + 1;
+			shift_set = (ccsidr & 0x07U) + 4;
+			no_ways = ((ccsidr >> 3) & 0x3ffU) + 1;
+			shift_way = count_leading_zero(no_ways - 1);
+
+			for (way = 0; way < no_ways; way++) {
+				waylevel = (way << shift_way) | (level << 1);
+				for (set = 0; set < no_sets; set++) {
+					setwaylevel = waylevel | (set << shift_set);
+					CP15_WRITE_DCCISW(setwaylevel);
+				}
+			}
 		}
 	}
+	data_sync_barrier();
 }
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,7 +53,5 @@
  */
 #ifndef TOPPERS_MACRO_ONLY
-#ifndef TECSGEN
-#include "arm_insn.h"				/* tecsgenが解釈できないためスキップ */
-#endif /* TECSGEN */
+#include "arm_insn.h"
 #endif /*  TOPPERS_MACRO_ONLY */
 
@@ -117,4 +115,12 @@
 #define CP15_SCTLR_DCACHE		UINT_C(0x00000004)
 #define CP15_SCTLR_MMU			UINT_C(0x00000001)
+
+/*
+ *  CP15のコプロセッサアクセス制御レジスタ（CPACR）の設定値
+ */
+#define CP15_CPACR_ASEDIS			UINT_C(0x80000000)
+#define CP15_CPACR_D32DIS			UINT_C(0x40000000)
+#define CP15_CPACR_CP11_FULLACCESS	UINT_C(0x00c00000)
+#define CP15_CPACR_CP10_FULLACCESS	UINT_C(0x00300000)
 
 /*
@@ -193,7 +199,4 @@
 #define ARM_MMU_DSCR1_TEX010		0x02000U	/* TEXビットが010 */
 #define ARM_MMU_DSCR1_TEX100		0x04000U	/* TEXビットが100 */
-#define ARM_MMU_DSCR1_AP01			0x00400U	/* APビットが01 */
-#define ARM_MMU_DSCR1_AP10			0x00800U	/* APビットが10 */
-#define ARM_MMU_DSCR1_AP11			0x00c00U	/* APビットが11 */
 #define ARM_MMU_DSCR1_CB00			0x00000U	/* Cビットが0，Bビットが0 */
 #define ARM_MMU_DSCR1_CB01			0x00004U	/* Cビットが0，Bビットが1 */
@@ -201,11 +204,23 @@
 #define ARM_MMU_DSCR1_CB11			0x0000cU	/* Cビットが1，Bビットが1 */
 
-#if __TARGET_ARCH_ARM >= 6
+#if __TARGET_ARCH_ARM < 6
+
+#define ARMV5_MMU_DSCR1_AP01		0x00400U	/* APビットが01 */
+#define ARMV5_MMU_DSCR1_AP10		0x00800U	/* APビットが10 */
+#define ARMV5_MMU_DSCR1_AP11		0x00c00U	/* APビットが11 */
+
+#else /* __TARGET_ARCH_ARM < 6 */
+
 #define ARMV6_MMU_DSCR1_NONGLOBAL	0x20000U	/* グローバルでない */
-#define ARMV6_MMU_DSCR1_APX0		0x00000U	/* APXビットが0 */
-#define ARMV6_MMU_DSCR1_APX1		0x08000U	/* APXビットが1 */
+#define ARMV6_MMU_DSCR1_AP001		0x00400		/* APビットが001 */
+#define ARMV6_MMU_DSCR1_AP010		0x00800		/* APビットが010 */
+#define ARMV6_MMU_DSCR1_AP011		0x00c00		/* APビットが011 */
+#define ARMV6_MMU_DSCR1_AP101		0x08400		/* APビットが101 */
+#define ARMV6_MMU_DSCR1_AP110		0x08800		/* APビットが110 */
+#define ARMV6_MMU_DSCR1_AP111		0x08c00		/* APビットが111 */
 #define ARMV6_MMU_DSCR1_ECC			0x00200U	/* ECCが有効（MPCore）*/
 #define ARMV6_MMU_DSCR1_NOEXEC		0x00010U	/* 実行不可 */
-#endif /* __TARGET_ARCH_ARM >= 6 */
+
+#endif /* __TARGET_ARCH_ARM < 6 */
 
 /*
@@ -237,9 +252,10 @@
 #define ARMV6_MMU_DSCR2_NONGLOBAL	0x0800U		/* グローバルでない */
 #define ARMV6_MMU_DSCR2_SHARED		0x0400U		/* プロセッサ間で共有 */
-#define ARMV6_MMU_DSCR2_APX0		0x0000U		/* APXビットが0 */
-#define ARMV6_MMU_DSCR2_APX1		0x0200U		/* APXビットが1 */
-#define ARMV6_MMU_DSCR2_AP01		0x0010U		/* APビットが01 */
-#define ARMV6_MMU_DSCR2_AP10		0x0020U		/* APビットが10 */
-#define ARMV6_MMU_DSCR2_AP11		0x0030U		/* APビットが11 */
+#define ARMV6_MMU_DSCR2_AP001		0x0010		/* APビットが001 */
+#define ARMV6_MMU_DSCR2_AP010		0x0020		/* APビットが010 */
+#define ARMV6_MMU_DSCR2_AP011		0x0030		/* APビットが011 */
+#define ARMV6_MMU_DSCR2_AP101		0x0210		/* APビットが101 */
+#define ARMV6_MMU_DSCR2_AP110		0x0220		/* APビットが110 */
+#define ARMV6_MMU_DSCR2_AP111		0x0230		/* APビットが111 */
 
 /* ラージページのディスクリプタ用 */
@@ -318,18 +334,19 @@
 
 /*
- *  プロセッサ番号の取得
+ *  自プロセッサのインデックス（0オリジン）の取得
  *
- *  マルチプロセッサアフィニティレジスタを読んで，その下位8ビットを返す．
- *  ARMv6では，マルチプロセッサをサポートしている場合にのみ使用できる．
+ *  マルチプロセッサアフィニティレジスタを読んで，その下位8ビットを返
+ *  す．ARMv6では，マルチプロセッサをサポートしている場合にのみ使用で
+ *  きる．
  */
 #if __TARGET_ARCH_ARM >= 6
 
-Inline uint32_t
-arm_prc_index(void)
+Inline uint_t
+get_my_prcidx(void)
 {
 	uint32_t	reg;
 
 	CP15_READ_MPIDR(reg);
-	return(reg & 0xffU);
+	return((uint_t)(reg & 0xffU));
 }
 
@@ -444,3 +461,9 @@
 
 #endif /* TOPPERS_MACRO_ONLY */
+
+/*
+ *  浮動小数点例外制御レジスタ（FPEXC）の設定値
+ */
+#define FPEXC_ENABLE		UINT_C(0x40000000)
+
 #endif /* TOPPERS_ARM_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm_insn.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm_insn.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/arm_insn.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -105,4 +105,8 @@
  *  Thumbモードではmrs/msr命令が使用できないため，関数として実現して，
  *  ARMモードに移行して実行する．
+ *
+ *  current_cpsrとset_cpsrは，__thumb__が定義されない場合にはヘッダファ
+ *  イル中で定義されるインライン関数になるため，core_rename.defに登録
+ *  せず，先頭の_kernel_を手書きしている．
  */
 
@@ -110,10 +114,12 @@
  *  ステータスレジスタ（CPSR）の現在値の読出し
  */
-extern uint32_t current_cpsr(void);
+extern uint32_t _kernel_current_cpsr(void);
+#define current_cpsr()	_kernel_current_cpsr()
 
 /*
  *  ステータスレジスタ（CPSR）の現在値の変更
  */
-extern void set_cpsr(uint32_t cpsr);
+extern void _kernel_set_cpsr(uint32_t cpsr);
+#define set_cpsr(cpsr)	_kernel_set_cpsr(cpsr)
 
 #endif /* __thumb__ */
@@ -220,4 +226,8 @@
 #define CP15_READ_ACTLR(reg)	Asm("mrc p15, 0, %0, c1, c0, 1":"=r"(reg))
 #define CP15_WRITE_ACTLR(reg)	Asm("mcr p15, 0, %0, c1, c0, 1"::"r"(reg))
+
+/* コプロセッサアクセス制御レジスタ */
+#define CP15_READ_CPACR(reg)	Asm("mrc p15, 0, %0, c1, c0, 2":"=r"(reg))
+#define CP15_WRITE_CPACR(reg)	Asm("mcr p15, 0, %0, c1, c0, 2"::"r"(reg))
 
 /*
@@ -293,9 +303,9 @@
 
 /* ドメインアクセス制御レジスタ */
-#define CP15_WRITE_DACR(reg)	Asm("mcr p15, 0, %0, c3, c0, 0":: "r"(reg))
+#define CP15_WRITE_DACR(reg)	Asm("mcr p15, 0, %0, c3, c0, 0"::"r"(reg))
 
 /* コンテキストIDレジスタ（ARMv6以降）*/
 #if __TARGET_ARCH_ARM >= 6
-#define CP15_WRITE_CONTEXTIDR(reg) Asm("mcr p15, 0, %0, c13, c0, 1" ::"r"(reg))
+#define CP15_WRITE_CONTEXTIDR(reg) Asm("mcr p15, 0, %0, c13, c0, 1"::"r"(reg))
 #endif /* __TARGET_ARCH_ARM >= 6 */
 
@@ -415,3 +425,25 @@
 
 #endif /* __TARGET_ARCH_ARM == 7 */
+
+/*
+ *  浮動小数点例外制御レジスタ（FPEXC）の現在値の読出し
+ */
+Inline uint32_t
+current_fpexc(void)
+{
+	uint32_t	fpexc;
+
+	Asm("vmrs %0, fpexc" : "=r"(fpexc));
+	return(fpexc);
+}
+
+/*
+ *  浮動小数点例外制御レジスタ（FPEXC）の現在値の変更
+ */
+Inline void
+set_fpexc(uint32_t fpexc)
+{
+	Asm("vmsr fpexc, %0" : : "r"(fpexc));
+}
+
 #endif /* TOPPERS_ARM_INSN_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_cfg1_out.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_cfg1_out.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_cfg1_out.h	(revision 429)
@@ -5,17 +5,6 @@
  */
 
-/*
- *  cfg1_out.cのリンクに必要な定義
- */
-
 #include <kernel.h>
 
-void sta_ker(void){}
+void sta_ker(void) { }
 STK_T *const	_kernel_istkpt;
-
-/*
- *  offset.hを生成するための定義
- */
-const uint8_t	MAGIC_1 = 0x12;
-const uint16_t	MAGIC_2 = 0x1234;
-const uint32_t	MAGIC_4 = 0x12345678;
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_check.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_check.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_check.trb	(revision 429)
@@ -3,5 +3,5 @@
 #		パス3の生成スクリプトのコア依存部（ARM用）
 # 
-#  $Id$
+#  $Id: core_check.trb 730 2016-04-03 02:04:52Z ertl-hiro $
 #
 
@@ -20,5 +20,5 @@
 inhTable = SYMBOL("_kernel_inh_table")
 offset = SYMBOL("__etext") - SYMBOL("__data_start__")
-$cfgData[:DEF_INH].each do |key, params|
+$cfgData[:DEF_INH].each do |_, params|
   inthdr = PEEK(inhTable + offset + params[:inhno] * $sizeof_FP, $sizeof_FP)
 
@@ -39,5 +39,5 @@
 #
 excTable = SYMBOL("_kernel_exc_table")
-$cfgData[:DEF_EXC].each do |key, params|
+$cfgData[:DEF_EXC].each do |_, params|
   exchdr = PEEK(excTable + params[:excno] * $sizeof_FP, $sizeof_FP)
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_kernel.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,4 +53,9 @@
 
 /*
+ *  ターゲット定義のタスク属性
+ */
+#define TA_FPU		UINT_C(0x08)	/* FPUレジスタをコンテキストに含める */
+
+/*
  *  スタックの型
  *
@@ -62,15 +67,16 @@
  *  CPU例外ハンドラ番号の数
  */  
-#define TNUM_EXCNO		6
+#define TNUM_EXCNO		7
 
 /*
  *  CPU例外ハンドラ番号の定義
  */
-#define EXCNO_UNDEF		0
-#define EXCNO_SVC		1
-#define EXCNO_PABORT	2
-#define EXCNO_DABORT	3
-#define EXCNO_IRQ		4
-#define EXCNO_FIQ		5
+#define EXCNO_UNDEF		UINT_C(0)		/* 未定義命令 */
+#define EXCNO_SVC		UINT_C(1)		/* スーパバイザコール */
+#define EXCNO_PABORT	UINT_C(2)		/* プリフェッチアボート */
+#define EXCNO_DABORT	UINT_C(3)		/* データアボート */
+#define EXCNO_IRQ		UINT_C(4)		/* IRQ割込み */
+#define EXCNO_FIQ		UINT_C(5)		/* FIQ割込み */
+#define EXCNO_FATAL		UINT_C(6)		/* フェイタルデータアボート */
 
 #ifndef TOPPERS_MACRO_ONLY
